unit unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, fspTaskbarMgr, fspTaskbarPreviews,
  fspTaskbarApi, AppEvnts, ImgList, ExtCtrls;

type
  TForm1 = class(TForm)
    Label2: TLabel;
    ComboBox1: TComboBox;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    fspTaskbarMgr1: TfspTaskbarMgr;
    Label3: TLabel;
    lblAPPID: TLabel;
    Panel1: TPanel;
    Image1: TImage;
    CheckBox1: TCheckBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ImageList1: TImageList;
    CheckBox2: TCheckBox;
    Image2: TImage;
    Timer1: TTimer;
    ApplicationEvents1: TApplicationEvents;
    fspTaskbarPreviews1: TfspTaskbarPreviews;
    procedure TrackBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure fspTaskbarPreviews1NeedIconicBitmap(Sender: TObject; Width,
      Height: Integer; var Bitmap: HBITMAP);
    procedure fspTaskbarPreviews1NeedIconicLivePreview(Sender: TObject;
      var Bitmap: HBITMAP; var Origin: TPoint);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure fspTaskbarMgr1ThumbButtonClick(Sender: TObject;
      ButtonId: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses fspControlsExt, commctrl;

{$R *.DFM}


procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  fspTaskbarMgr1.ProgressValue :=  TrackBar1.Position;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  fspTaskbarMgr1.ProgressValueMax :=  TrackBar1.Max;
  fspTaskbarMgr1.AppId := 'MyAppID_' + IntToStr(Random (1000));
  lblAPPID.Caption := fspTaskbarMgr1.AppId;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  fspTaskbarMgr1.ProgressState := TfspTaskProgressState(ComboBox1.ItemIndex);
end;

procedure TForm1.fspTaskbarPreviews1NeedIconicBitmap(Sender: TObject;
  Width, Height: Integer; var Bitmap: HBITMAP);
begin
  Bitmap := fspControl2DIBPreview(Panel1, Panel1.ClientRect, Width, Height);
end;

procedure TForm1.fspTaskbarPreviews1NeedIconicLivePreview(Sender: TObject;
  var Bitmap: HBITMAP; var Origin: TPoint);
var
  DC : HDC;
begin
// Set CustomLiveView to True for this code.
  //inversed live view
  Bitmap := fspControl2DIB(Self);
  Origin.x := 0;
  Origin.y := 0;
  DC := CreateCompatibleDC(0);
  SelectObject(DC, Bitmap);
  BitBlt(DC, 0, 0, Width, Height, 0, 0, 0, DSTINVERT);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
    fspTaskbarMgr1.OverlayIcon := Image2.Picture.Icon
  else
    fspTaskbarMgr1.OverlayIcon := nil;
end;


procedure TForm1.CheckBox2Click(Sender: TObject);
var
  i : Integer;
begin
  fspTaskbarMgr1.ThumbsBeginUpdate;
  for i := 0 to fspTaskbarMgr1.ThumbButtons.Count - 1 do
    with fspTaskbarMgr1.ThumbButtons[i] do
      if CheckBox2.Checked  then
        Flags := Flags - [fsttfDisable]
      else
        Flags := Flags + [fsttfDisable];
  fspTaskbarMgr1.ThumbsEndUpdate;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Image2.Visible := not Image2.Visible;
  fspTaskbarPreviews1.InvalidatePreview;
end;

procedure TForm1.fspTaskbarMgr1ThumbButtonClick(Sender: TObject;
  ButtonId: Integer);
begin
  Application.MessageBox(PChar('Thumb Button '+IntToStr(ButtonID)), 'Button clicked', 0);
end;

end.
